#include <errno.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <limits.h>
#include <time.h>

#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <string>
//#include <pair.h>
#include <vector>
#include <map>

//#define DEBUG

#define MAXLINE 512

#define MSG_SIZE 32768

//using std::pair;
using std::string;
using std::vector;
using std::map;

//global variables
int option_1; //postmertem profile
int option_s; //server 
int option_p; //port
int option_i; //interval
int option_d; //data directory
int option_a; //asynchronous mode
int option_n; //number of nodes
int option_c; //number of contexts
int option_t; //number of threads
int option_m; //max number of seq

int port;
int interval; //seconds
int num_node;
int num_context;
int num_thread;
long max_seq;
long cur_seq;

char server_name[256];
char directory[256];
char dump_file[256];

vector<string>* file_vecs;
vector<string>* key_vecs;
map<string, long> file_map;

int map_timestamp(char* line, char* key)
{
  int i;
  char tmp_line[256];
  char date_time[21];
  char* month;
  char* day;
  char* hour;
  char* minute;
  char* second;
  char* year;
  char month_key[4];
  char day_key[3];
  char hour_key[3];
  char minute_key[3];
  char second_key[3];
  char year_key[5];
  char* months[12]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
  
  strcpy(tmp_line,line);

  if(strncmp(tmp_line,"dump__",6)!=0)
    return -1;

  strcpy(date_time,tmp_line+10);

  month = strtok(date_time,"-");
  for(i = 0; i < 12; i++){
    if(strcmp(month,months[i])==0)
      break;
  }
  if(i == 12)
    return -1;

  if(i+1 < 10)
    sprintf(month_key,"0%d",i+1);
  else
    sprintf(month_key,"%d",i+1);

  day = strtok(NULL,"-");
  if(strlen(day) == 1)
    sprintf(day_key,"0%s",day);
  else 
    strcpy(day_key,day);

  hour = strtok(NULL,":");
  if(strlen(hour) ==1)
    sprintf(hour_key,"0%s",hour);
  else
    strcpy(hour_key,hour);

  minute = strtok(NULL,":");
  if(strlen(minute) == 1)
    sprintf(minute_key,"0%s",minute);
  else
    strcpy(minute_key,minute);

  second = strtok(NULL,"-");
  if(strlen(second) == 1)
    sprintf(second_key,"0%s",second);
  else
    strcpy(second_key,second);

  year = strtok(NULL,"_");
  strcpy(year_key,year);

  key[0]= '\0';
  strcat(key,year_key);
  strcat(key,month_key);
  strcat(key,day_key);
  strcat(key,hour_key);
  strcat(key,minute_key);
  strcat(key,second_key);

  return 0;
}

int get_profile_file()
{
  char line[256];
  FILE *fp;
  
  if((fp = popen("ls -1 -t -r", "r")) == NULL){
    perror("popen error");
    pclose(fp);
    return -1;
  }
  
  while(fgets(line,256,fp)!=0){
    if(strncmp(line,"profile",7) == 0)
       return 0;
  }
  pclose(fp);

  return -1;
}

int get_dump_file()
{
  int return_value;
  char line[256];
  FILE *fp;

  if((fp = popen("ls -1 -t -r", "r")) == NULL){
    perror("popen error");
    pclose(fp);
    return -1;
  }
#ifdef DEBUG
  printf("get_dump_file: popen sucess\n");
#endif

  return_value  = 0;

  while(fgets(line,256,fp)!=0){
#ifdef DEBUG
    printf("get_dump_file: %s\n",line);
#endif

    if(strncmp(line,"dump.",5) == 0){
      if(return_value==0)
	return_value = 1;
    }
    else if(strncmp(line,"profile",7) == 0){
      return_value = 2;
    }
  }

  pclose(fp);
  return return_value;
}

///////////////////////////////////
// 1: next dump file
// 2: profile file
// -1: error

int get_next_dump_file()
{
  int final_profile = 0;
  int i,j;
  int inode, icontext, ithread;
  int index;
  char line[256];
  char date_time_key[15];
  char* node, *context, *thread;
  FILE *fp;
  vector<string>::iterator pos;
  vector<string>* file_vec;
  vector<string>* key_vec;

  if(cur_seq < max_seq ) {
    sprintf(dump_file,"dump--%.12d",cur_seq);
    cur_seq ++;
    if(cur_seq == max_seq)
      return 2;
    else
      return 1;
  }
 

  if((fp = popen("ls -1", "r")) == NULL){
    perror("popen error");
    pclose(fp);
    return -1;
  }

  while(fgets(line,256,fp)!=0){
    //printf("%s\n", line);
      
    if(map_timestamp(line,date_time_key)<0){
      if(strncmp(line,"profile",7) == 0 ) 
        final_profile = 1;
      
      continue;
    }

#ifdef DEBUG
    printf("checking %s\n",line);
#endif

    if (file_map.find(line) != file_map.end()) {
#ifdef DEBUG
      printf("found in file_map\n");
#endif
      continue;
    }

    char tmp_line[256];
    char* tmp_line2;
    strcpy(tmp_line, line);
    tmp_line2 = strtok(tmp_line,"\n");

    node = strtok(NULL,".");
    context = strtok(NULL,".");
    thread = strtok(NULL,".");

#ifdef DEBUG
    printf("node %s context %s thread %s \n", node, context, thread);
#endif

    inode = atoi(node);
    icontext = atoi(context);
    ithread = atoi(thread);

#ifdef DEBUG
    printf("key is %s\n",date_time_key);
#endif 

    index = inode * (num_context * num_thread) + icontext * num_thread + ithread;
    key_vec = &(key_vecs[index]);
    file_vec = &(file_vecs[index]);

    for(i=0,pos = key_vec->begin(); pos != key_vec->end(); pos++,i++){
      int cmp_result = strcmp(date_time_key, (*pos).c_str());
      if(cmp_result < 0) {
	key_vec->insert(pos, date_time_key);
	file_vec->insert(file_vec->begin() + i, tmp_line2);
	break;
      }
    }

    if(pos == key_vec->end()) {
      key_vec->push_back(date_time_key);
      file_vec->push_back(tmp_line2);
    }

  }

  pclose(fp);

  int num_vecs = num_node * num_context * num_thread;
  int min_size;
  min_size = file_vecs[0].size();

  for(i=1; i<num_vecs; i++){
    int size = file_vecs[i].size();
    if(size < min_size)
      min_size = size;
  }
  
#ifdef DEBUG
  printf("min_size %d num_vecs %d\n", min_size, num_vecs);
#endif


  max_seq += min_size;
  for(i=0; i<num_vecs; i++){
    for(j=0; j<min_size; j++){
      char tmp_file[256];
      strcpy(tmp_file, file_vecs[i][j].c_str());
      char* suffix = strchr(tmp_file, '.');
      sprintf(dump_file, "dump--%.12d", cur_seq+j);
      strcat(dump_file, suffix);

      printf("rename %s to %s\n",file_vecs[i][j].c_str(),  dump_file);

      rename(file_vecs[i][j].c_str(), dump_file);

      file_map[file_vecs[i][j] ] = cur_seq + j;
    }
  }

#ifdef DEBUG
  printf("rename success\n");
#endif

  if(min_size > 0) {
    for(i=0; i<num_vecs; i++){
      file_vecs[i].erase(file_vecs[i].begin(), file_vecs[i].begin()+min_size);
      key_vecs[i].erase(key_vecs[i].begin(),key_vecs[i].begin()+min_size);
    }
  }

#ifdef DEBUG
  printf("erase success\n");
#endif

  if(cur_seq < max_seq) {
    sprintf(dump_file,"dump--%.12d",cur_seq);
    cur_seq ++;
    return 1;
  } else if(cur_seq == max_seq) {
    if(final_profile)
      return 2;
  } 

  return 0;
}

int parse_args(int argc,char** argv)
{
  extern char *optarg;
  extern int optind;
  int c;
  int err = 0;

  option_s = 0;
  option_p = 0;
  option_d = 0;
  option_i = 0;
  option_a = 0;
  option_1 = 0;
  option_m = 0;
  option_n = 0;
  option_c = 0;
  option_t = 0;

  num_node = 1;
  num_context = 1;
  num_thread = 1;
  max_seq = 0;
  interval = 0;
  port = 12668;

  while((c = getopt(argc,argv,"s:p:d:i:n:c:t:m:1a"))!=-1){
    switch(c){
    case 's':
      if(strlen(optarg)==0){
	err++;
	break;
      }
      strcpy(server_name,optarg);
      option_s ++;
      break;
    case 'p':
      if(strlen(optarg)==0){
	err++;
	break;
      }
      if(port == INT_MIN || port == INT_MAX){
	err ++;
	break;
      }
      port = atoi(optarg);
      option_p ++;
      break;
    case 'd':
      if(strlen(optarg)==0){
	err++;
	break;
      }
      strcpy(directory,optarg);
      option_d ++;
      break;
    case 'i':
      if(strlen(optarg)==0){
	err++;
	break;
      }
      interval = atoi(optarg);
      option_i ++;
      break;
    case '1':
      option_1 ++;
      break;
    case 'a':
      option_a ++;
      break;
    case 'm':
      if(strlen(optarg) == 0){
	err++;
	break;
      }
      max_seq = atol(optarg);
      option_m ++;
      break;
    case 'n':
      if(strlen(optarg) == 0){
	err++;
	break;
      }
      num_node = atoi(optarg);
      option_n++;
      break;
    case 'c':
      if(strlen(optarg) == 0){
	err++;
	break;
      }
      num_context = atoi(optarg);
      option_c++;
      break;
    case 't':
      if(strlen(optarg) == 0) {
	err++;
	break;
      }
      num_thread = atoi(optarg);
      option_t++;
      break;
    case '?':
    default:
      err++;
      break;
    }
  }

  if(err){
    printf("Usage: integrator -n <num of nodes> -c <num of contexts> -t <num of threads> \n");
    printf("other options: [-s <server>] [-p <port>] [-d <data directory>] [-1] [-a] [-i <interval>]\n");

    return -1;
  }

  if(num_node * num_context * num_thread <=0){
    printf("number of nodes, contexts and threads must be greater than 0\n");
    return -1;
  }

  return 0;
}

int main(int argc, char **argv)
{
  int sockfd;
  int new_dump_file,new_profile_file;
  struct sockaddr_in servaddr;
  struct hostent *server;
  char command[256];
  char sendmsg[MSG_SIZE], recvmsg[512];
  FILE *fp;

  if(parse_args(argc,argv) == -1)
    exit(1);
#ifdef DEBUG
  printf("parse arguments success\n");
#endif

  if(option_d && chdir(directory) == -1){
    perror("chdir error");
    exit(1);
  }
#ifdef DEBUG
  printf("change directory sucess\n");
#endif

  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0){
    perror("socket error");
    exit(1);
  }

  if(!option_s){//get the local host
    if(gethostname(server_name,256) == -1){
      perror("gethostname error");
      exit(1);
    }
  }

  memset(&servaddr,0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_port = htons(port);
  if((server = gethostbyname(server_name)) == NULL){
    printf("server name error: %s\n",server_name);
    exit(1);
  }

  memcpy((char *)&servaddr.sin_addr.s_addr,
	 (char *)server->h_addr, 
         server->h_length);

  printf("connecting...\n");

  if(connect(sockfd, (struct sockaddr *) & servaddr, sizeof(servaddr)) == -1){
    printf("connect error %d\n",errno);
    exit(1);
  }

  printf("connected!\n");

#ifdef DEBUG
  printf("socket connection success\n");
#endif

  dump_file[0] = 0;
  cur_seq = 0;

  int num_vecs = num_node * num_context * num_thread;
  file_vecs = new vector<string>[num_vecs];
  key_vecs = new vector<string>[num_vecs];

  int return_value = 0;

  while(1){
    time_t time1 = time(NULL);

    if(option_1){
      new_profile_file = get_profile_file();
#ifdef DEBUG
      printf("result of get_profile_file is: %d\n",new_profile_file);
#endif

      if(new_profile_file < 0){
	perror("No profile files");
	return_value = 1;
	break;
      }
      printf("profile\n");
      strcpy(command,"pprof -d ");
      if((fp=popen(command, "r"))==NULL){
        perror("popen pipe error");
        return_value = 1;
	break;
      }
#ifdef DEBUG
      printf("popen success\n");
#endif
    }
    else if(option_a){
      new_dump_file = get_dump_file();
#ifdef DEBUG
      printf("result of get_dump_file is: %d\n",new_dump_file);
#endif

      if(new_dump_file <= 0){
	sleep(interval);
	continue;
      }
      printf("dump\n");
      strcpy(command,"pprof -d -f ");
      strcat(command,"dump");
      if((fp=popen(command,"r"))==NULL){
	perror("popen pipe error");
	return_value = 1;
	break;
      }
#ifdef DEBUG
      printf("popen success\n");
#endif
    }
    else{
      new_dump_file = get_next_dump_file();
#ifdef DEBUG
      printf("result of get_next_dump_file is: %d\n",new_dump_file);
#endif

      if(new_dump_file == 1 || new_dump_file == 2) {
        printf("%s.x.x.x\n",dump_file);
        strcpy(command,"pprof -d -f ");
        strcat(command, dump_file);
	if((fp=popen(command,"r"))==NULL){
	  perror("popen pipe error");
	  return_value = 1;
	  break;
	}
      } 
      else if(new_dump_file == -1){
	return_value = 1;
	break;
      }
      else
	continue;
#ifdef DEBUG
      printf("popen success\n");
#endif
    } 

    int send_cnt,send_len;
    char* tmp_sendmsg = sendmsg;
    
    if(!option_1 && new_dump_file == 1)
      strcpy(tmp_sendmsg,"intermediate");
    else if(option_1 || new_dump_file ==2)
      strcpy(tmp_sendmsg,"last");

    if(send(sockfd, tmp_sendmsg,strlen(tmp_sendmsg)+1,0) == -1){
      perror("send error");
      return_value = 1;
      break;
    }
#ifdef DEBUG
    printf("sending %s\n",tmp_sendmsg);
#endif

    
    // while( fgets(sendmsg,MSG_SIZE,fp)){
    // send_len = strlen(sendmsg);
    while(send_len = fread(sendmsg, 1,MSG_SIZE, fp)) {
      while((send_cnt = send(sockfd,tmp_sendmsg,send_len,0)) < send_len){
	if(send_cnt == -1){
	  perror("send error");
	  return_value = 1;
	  break;
	}
        send_len -= send_cnt;
        tmp_sendmsg += send_cnt;
      }
      if(return_value == 1)
	break;
    }
    if(return_value == 1)
      break;

    //send "end of file"
    sendmsg[0]=4;
    sendmsg[1]=0;
    if(send(sockfd,sendmsg, strlen(sendmsg),0) == -1){
      perror("send error");
      return_value = 1;
      break;
    }

    pclose(fp);

    if(recv(sockfd,recvmsg, 256,0) < 0){
      perror("recv error in integrator\n");
      return_value = 1;
      break;
    }

    time_t time2 = time(NULL);

    double elapsedSeconds = difftime(time2, time1);
    
    printf("%f seconds elapsed \n", elapsedSeconds);

#ifdef DEBUG
    printf("%s received\n",recvmsg);
#endif

    if(strcmp(recvmsg,"continue")==0){
      if(option_1 || new_dump_file == 2){
        if(send(sockfd,"stop",5,0) == -1){
	  perror("send error");
	  return_value = 1;
	  break;
	}
        break;
      }
    }
    else if(strcmp(recvmsg, "stop")==0)
      break;

    //if(option_a && option_i)
    if(interval > 0)
      sleep(interval);
  }

  delete []file_vecs;
  delete []key_vecs;

  return return_value;
}










